#include "orb_device.h"
#include "orb_translator.h"
#include "hid_keys.h"
#include "chart_4.h"

Logical_orb orb_buffer( SpaceOrb360 );
Orb_translator translator;
byte b;
boolean has_initialized_orb=false;

PROGMEM Axis_key_binding axis_key_bindings[] =
  {
    { 0, 0, 255, 0, KEY_O },
    { 0, 768, 1023, 0, KEY_U},
    { 1, 0, 255, 0, KEY_PERIOD},
    { 1, 768, 1023, 0, KEY_E},
    { 5, 0, 255, 0, KEY_COMMA },
    { 5, 768, 1023, 0, KEY_P }
  };

PROGMEM Button_key_binding button_key_bindings[] = 
  {
    { 0x01 << 1, MOD_SHIFT_LEFT, 0 },
    { 0x01 << 2, 0, KEY_H },
    { 0x01 << 3, 0, KEY_E },
    { 0x01 << 4, 0, KEY_L },
    { 0x01 << 5, 0, KEY_O }
  };

PROGMEM Axis_mouse_binding axis_mouse_bindings[] =
  {
    { 0, MOUSE_AXIS_X, 3 },
    { 1, MOUSE_AXIS_Y, 3 }
  };

PROGMEM Button_mouse_binding button_mouse_bindings[] =
  {
    { 0x01, 0x01 },
    { 0x01 << 1, 0x01 << 1 },
    { 0x01 << 2, 0x01 << 2 }
  };

void setup()
{
  Serial.begin( 9600 );

  translator.set_chording( false );
  //translator.set_axis_map( Axis_map_spaceball_4k );
  //translator.set_polarity( Polarity_spaceball_4k );
  translator.set_axis_map( Axis_map_spaceorb_face );
  translator.set_polarity( Polarity_spaceorb_face );
  translator.set_gain( 0 );
  translator.set_sensitivity_table( sensitivity_4_chart );

  //translator.set_axis_key_bindings( axis_key_bindings, 6 );
  //translator.set_button_key_bindings( button_key_bindings, 5 );
  //translator.set_axis_mouse_bindings( axis_mouse_bindings, 2 );
  //translator.set_button_mouse_bindings( button_mouse_bindings, 3 );
}

void loop()
{
  orb_device.refresh();
  if  ( Serial.available() )
  {
    b = Serial.read();
    orb_buffer.add_byte( b );
    if ( orb_buffer.has_changed() )
    {
      if ( (!has_initialized_orb) && (orb_buffer.physical_buttons & 1) )
      {
        orb_device.safe_send_serial_P(spaceball_setup_string);
        has_initialized_orb = true;
      }
      else if ( has_initialized_orb )
      {
      }
      //orb_device.refresh();
      //translator.translate_orb( orb_buffer, orb_device );
      //orb_buffer.log_change();
      translator.update(orb_buffer, orb_device);
    }
  }
}
